"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTemplateLoadingError = void 0;
const createTemplateLoadingError = (names) => {
    let message;
    if (names.length === 1) {
        const name = names[0];
        message = `Unable to find template "${name ? name : ''}".`;
    }
    else {
        message = `Unable to find one of the following templates: "${names.join('", "')}".`;
    }
    const error = Error(message);
    Error.captureStackTrace(error, exports.createTemplateLoadingError);
    return error;
};
exports.createTemplateLoadingError = createTemplateLoadingError;
