"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCssEscapingStrategyHandler = void 0;
const phpSprintf = require('locutus/php/strings/sprintf');
const createCssEscapingStrategyHandler = () => {
    return (value) => {
        value = value.replace(/[^a-zA-Z0-9]/ug, (character) => {
            const codePoint = character.codePointAt(0);
            return phpSprintf('\\u%04X', codePoint);
        });
        return value;
    };
};
exports.createCssEscapingStrategyHandler = createCssEscapingStrategyHandler;
