"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.escape = void 0;
const markup_1 = require("../../../markup");
const escape_value_1 = require("../../../helpers/escape-value");
const escape = (executionContext, value, strategy) => {
    if (strategy === null) {
        strategy = "html";
    }
    const { template, environment } = executionContext;
    // todo: probably we need to use traceable method
    return (0, escape_value_1.escapeValue)(template, environment, value, strategy, environment.charset)
        .then((value) => {
        if (typeof value === "string") {
            return (0, markup_1.createMarkup)(value, environment.charset);
        }
        return value;
    });
};
exports.escape = escape;
