"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTraceableMethod = void 0;
const runtime_1 = require("../error/runtime");
const error_1 = require("../error");
function getTraceableMethod(method, location, templateSource) {
    return ((...args) => {
        return method(...args)
            .catch((error) => {
            if (!(0, error_1.isATwingError)(error)) {
                throw (0, runtime_1.createRuntimeError)(error.message, location, templateSource, error);
            }
            throw error;
        });
    });
}
exports.getTraceableMethod = getTraceableMethod;
