"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeArrayNode = void 0;
const get_key_value_pairs_1 = require("../../helpers/get-key-value-pairs");
const executeArrayNode = async (baseNode, executionContext) => {
    const { nodeExecutor: execute } = executionContext;
    const keyValuePairs = (0, get_key_value_pairs_1.getKeyValuePairs)(baseNode);
    const array = [];
    for (const { value: valueNode } of keyValuePairs) {
        const value = await execute(valueNode, executionContext);
        if (valueNode.type === "spread") {
            array.push(...value);
        }
        else {
            array.push(value);
        }
    }
    return array;
};
exports.executeArrayNode = executeArrayNode;
