"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeEscapeNode = void 0;
const traceable_method_1 = require("../../helpers/traceable-method");
const escape_value_1 = require("../../helpers/escape-value");
const executeEscapeNode = (node, executionContext) => {
    const { template, environment, nodeExecutor: execute } = executionContext;
    const { strategy } = node.attributes;
    const { body } = node.children;
    return execute(body, executionContext)
        .then((value) => {
        const traceableEscape = (0, traceable_method_1.getTraceableMethod)(escape_value_1.escapeValue, node, template.source);
        return traceableEscape(template, environment, value, strategy, null);
    });
};
exports.executeEscapeNode = executeEscapeNode;
