"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeParentFunction = void 0;
const traceable_method_1 = require("../../helpers/traceable-method");
const executeParentFunction = (node, executionContext) => {
    const { template, outputBuffer } = executionContext;
    const { name } = node.attributes;
    const displayParentBlock = (0, traceable_method_1.getTraceableMethod)(template.displayParentBlock, node, template.source);
    outputBuffer.start();
    return displayParentBlock(executionContext, name).then(() => outputBuffer.getAndClean());
};
exports.executeParentFunction = executeParentFunction;
