"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeBaseIncludeNode = void 0;
const traceable_method_1 = require("../helpers/traceable-method");
const include_1 = require("../extension/core/functions/include");
const executeBaseIncludeNode = async (node, executionContext, getTemplate) => {
    const { nodeExecutor: execute, outputBuffer, sandboxed, template } = executionContext;
    const { variables } = node.children;
    const { only, ignoreMissing } = node.attributes;
    const templatesToInclude = await getTemplate(executionContext);
    const traceableInclude = (0, traceable_method_1.getTraceableMethod)(include_1.include, node, template.source);
    const output = await traceableInclude(executionContext, templatesToInclude, await execute(variables, executionContext), !only, ignoreMissing, sandboxed);
    outputBuffer.echo(output);
};
exports.executeBaseIncludeNode = executeBaseIncludeNode;
