"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.executePrintNode = void 0;
const executePrintNode = (node, executionContext) => {
    const { template, nodeExecutor: execute, outputBuffer, sourceMapRuntime } = executionContext;
    sourceMapRuntime === null || sourceMapRuntime === void 0 ? void 0 : sourceMapRuntime.enterSourceMapBlock(node.line, node.column, node.type, template.source, outputBuffer);
    return execute(node.children.expression, executionContext)
        .then((result) => {
        if (Array.isArray(result)) {
            result = 'Array';
        }
        outputBuffer.echo(result);
        sourceMapRuntime === null || sourceMapRuntime === void 0 ? void 0 : sourceMapRuntime.leaveSourceMapBlock(outputBuffer);
    });
};
exports.executePrintNode = executePrintNode;
