"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeTemplateNode = void 0;
const executeTemplateNode = (node, executionContext) => {
    const { template, nodeExecutor: execute, outputBuffer, sourceMapRuntime } = executionContext;
    const { securityCheck, body } = node.children;
    return execute(securityCheck, executionContext)
        .then(() => {
        sourceMapRuntime === null || sourceMapRuntime === void 0 ? void 0 : sourceMapRuntime.enterSourceMapBlock(node.line, node.column, node.type, template.source, outputBuffer);
        return execute(body, executionContext).then(() => {
            sourceMapRuntime === null || sourceMapRuntime === void 0 ? void 0 : sourceMapRuntime.leaveSourceMapBlock(outputBuffer);
        });
    });
};
exports.executeTemplateNode = executeTemplateNode;
