"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cloneGetAttributeNode = exports.createAttributeAccessorNode = void 0;
const expression_1 = require("../expression");
const createAttributeAccessorNode = (target, attribute, methodArguments, type, line, column) => {
    return (0, expression_1.createBaseExpressionNode)("attribute_accessor", {
        isOptimizable: true,
        type,
        shouldTestExistence: false
    }, {
        target,
        attribute,
        arguments: methodArguments
    }, line, column);
};
exports.createAttributeAccessorNode = createAttributeAccessorNode;
const cloneGetAttributeNode = (attributeAccessorNode) => {
    const { children, attributes, line, column } = attributeAccessorNode;
    const { arguments: methodArguments, attribute, target } = children;
    const { type } = attributes;
    return (0, exports.createAttributeAccessorNode)(target, attribute, methodArguments, type, line, column);
};
exports.cloneGetAttributeNode = cloneGetAttributeNode;
