"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBinaryNodeFactory = exports.createBaseBinaryNode = void 0;
const expression_1 = require("../expression");
const createBaseBinaryNode = (type, operands, line, column) => {
    const baseNode = (0, expression_1.createBaseExpressionNode)(type, {}, {
        left: operands[0],
        right: operands[1]
    }, line, column);
    return Object.assign({}, baseNode);
};
exports.createBaseBinaryNode = createBaseBinaryNode;
const createBinaryNodeFactory = (type) => {
    const factory = (operands, line, column) => {
        const baseNode = (0, exports.createBaseBinaryNode)(type, operands, line, column);
        return Object.assign({}, baseNode);
    };
    return factory;
};
exports.createBinaryNodeFactory = createBinaryNodeFactory;
