"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBaseUnaryNode = exports.createUnaryNodeFactory = void 0;
const expression_1 = require("../expression");
const createUnaryNodeFactory = (type) => {
    const factory = (operand, line, column) => {
        const baseNode = (0, exports.createBaseUnaryNode)(type, operand, line, column);
        return Object.assign({}, baseNode);
    };
    return factory;
};
exports.createUnaryNodeFactory = createUnaryNodeFactory;
const createBaseUnaryNode = (type, operand, line, column) => {
    const baseNode = (0, expression_1.createBaseExpressionNode)(type, {}, {
        operand
    }, line, column);
    return Object.assign({}, baseNode);
};
exports.createBaseUnaryNode = createBaseUnaryNode;
