"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTemplateNode = void 0;
const node_1 = require("../node");
const createTemplateNode = (body, parent, blocks, macros, traits, embeddedTemplates, source, line, column) => {
    const children = {
        body,
        blocks,
        macros,
        traits,
        securityCheck: (0, node_1.createNode)()
    };
    if (parent !== null) {
        children.parent = parent;
    }
    const baseNode = (0, node_1.createBaseNode)("template", {
        index: 0,
        source
    }, children, line, column);
    return Object.assign(Object.assign({}, baseNode), { get embeddedTemplates() {
            return embeddedTemplates;
        } });
};
exports.createTemplateNode = createTemplateNode;
