import type { TwingBaseNode } from "./node";
import type { TwingExecutionContext } from "./execution-context";
export type TwingNodeExecutor<Node extends TwingBaseNode = TwingBaseNode> = (node: Node, executionContext: TwingExecutionContext) => Promise<any>;
/**
 * Execute the passed node against the passed execution context.
 *
 * @param node The node to execute
 * @param executionContext The context the node is executed against
 */
export declare const executeNode: TwingNodeExecutor;
